#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <unistd.h>

static vector <string> lines;
static unsigned pos = 0;

static bool get(string &s)
{
	if(pos < lines.size())
	{
		s = lines[pos++];
		return true;
	}
	return false;
}
static void unget()
{
	if(pos>0)--pos;
}

static unsigned common1(const string &s1, const string &s2)
{
	const char *a = s1.c_str();
	const char *b = s2.c_str();
	unsigned n;
	for(n=0; *a == *b && *a; ++n, ++a, ++b);
	return n;	
}

static unsigned common2(const string &s1, const string &s2)
{
	const char *a = s1.c_str();
	const char *b = s2.c_str();
	unsigned n = s1.size(); a += n;
	unsigned m = s2.size(); b += m;
	
	// m = maxlength, that is minimum of sizes.
	
	if(n < m)m = n;
	
	for(n=0; m>0 && *--a == *--b; ++n)--m;
	
	return n;
}

static string pack(const string &commonpart1, const string &commonpart2)
{
	string result;
	bool jotain = false;
	char sep = commonpart1.size() || commonpart2.size() ? ',' : ' ';	
	for(; ; jotain=true)
	{
		string s;
		if(!get(s))break;
		
		if(s.size() < commonpart1.size() + commonpart2.size())
			break;
		
		if(s.substr(0, commonpart1.size()) != commonpart1
		|| s.substr(s.size() - commonpart2.size()) != commonpart2)
		{
			unget();
			break;
		}
		
		string s2;
		if(get(s2))
		{
    		unget();
    		
    		unsigned len1 = common1(s, s2);
    		unsigned len2 = common2(s, s2);
    		
    		if(s2.substr(0, commonpart1.size()) == commonpart1
    		&& s2.substr(s2.size() - commonpart2.size()) == commonpart2)
    		{
        		if(len1 > commonpart1.size() + 1
        		|| len2 > commonpart2.size() + 1)
        		{
        			unget(); // unget s
    	    		if(jotain)result += sep;
        			result += s.substr(commonpart1.size(), len1 - commonpart1.size());
        			result += '{';
        			result += pack(s.substr(0, len1), s.substr(s.size() - len2));
        			result += '}';
        			result += s.substr(s.size() - len2, len2 - commonpart2.size());
        			continue;
        		}
    		}
		}
		
   		if(jotain)result += sep;
		result += s.substr(commonpart1.size(), s.size() - commonpart1.size() - commonpart2.size());
	}
	return result;
}

int main()
{
	if(isatty(0))
	{
		cout <<
			"Shellpack version "VERSION" - (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)\n"
		    "Usage: shellpack < data.txt\n\n"
		    "Compresses text lines with sh syntax.\n\n"
		    "Example (/exec -msg bisqwit = ircII command, rest is shell commandline):\n"
		    "\n    /exec -msg bisqwit grep : .jnewsrc|sed 's/:.*//'|shellpack\n\n"
		    "Produces compact output like \"sfnet.tiede.{bio,fysiikka}\".\n\n";
		return 0;
	}
	for(;;)
	{
		string s;
		getline(cin, s);
		if(!cin.good())break;
		lines.push_back(s);
	}
	sort(lines.begin(), lines.end());
	
	cout << pack("", "") << endl;
	
	return 0;
}
